SET SCHEMA FN24_45803;

-- Trigger that adds a new entry to LogHistory after a new file is added
CREATE TRIGGER AddLogHistory
    AFTER INSERT ON LOGFILE
    REFERENCING NEW AS NEW_ROW
    FOR EACH ROW
    BEGIN
       INSERT INTO LOGHISTORY (USERID, FILENAME)
        VALUES (NEW_ROW.USERID, NEW_ROW.NAME);
    END;

--test
INSERT INTO LOGFILE (HASH, USERID, NAME, CONTENT) VALUES
('-1432701900', 2, 'simple.txt', '{"john_smith":30,"peter_johnson":30}');

-- If filename or content changes update timestamp
CREATE TRIGGER UpdateLogfileTimestamp
AFTER UPDATE OF CONTENT ON FN24_45803.LOGFILE
REFERENCING OLD AS OLD_ROWS
FOR EACH ROW
BEGIN ATOMIC
    UPDATE FN24_45803.LOGFILE
    SET TIMESTAMP = CURRENT_TIMESTAMP
    WHERE HASH = OLD_ROWS.HASH AND USERID = OLD_ROWS.USERID;
END;

--test
UPDATE FN24_45803.LOGFILE
SET CONTENT = '{"PETER":40}'
WHERE HASH = '-1432701900' AND USERID = 1;
